package sklep.controller;

import jakarta.persistence.EntityManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import sklep.model.Product;

import java.util.List;


@Controller
@RequestMapping("/products")
public class ProductController {
    @Autowired
    private EntityManager em;

    @GetMapping
    public String readAll(Model model) {
        List<Product> products = em.createNamedQuery("Product.findAll", Product.class).getResultList();
        model.addAttribute("products", products);
        return "/products.jsp";
    }

    @GetMapping("/{id}")
    public String readOne(@PathVariable("id") Integer productId, Model model) {
        Product product = em.find(Product.class, productId);
        if(product != null) {
            model.addAttribute("product", product);
            return "/product.jsp";
        } else {
            return "/missing_product.jsp";
        }
    }
}
